package v1;
import java.util.*;

//Une partie représente le client et le joueur
//Chaque sous-classe concrète (comme Partie1) représente une partie 
//spécifique

public abstract class BasePartie {
	protected ArrayList<Bidon> bidons;
	protected int volumeVisé; //volume à atteindre
	protected int nbBidons;   //nombre de bidons
	
	//le constructeur crée 'nbBidons' bidons, dans une collection,
	//les parties concrètes pourront les référencer via des variables.
	//
	public BasePartie(int nbBidons, int[] capacites, int but) {
		volumeVisé = but;
		nbBidons = capacites.length;
		bidons = new ArrayList<Bidon>(nbBidons);
		for(int i = 0; i<nbBidons; i++) {
			bidons.add(i, new Bidon(capacites[i],i+1));}
		}
	
	//une méthode jouer crée des commandes et les passe
	//au lanceur qui les exécute.
	public abstract Collection<ICommande>  jouer();
	
	public void printEtats() {
		String s = "Etats : ";
		for (Bidon b : bidons)
			s = s + b.toStringContent();
		System.out.println(s);
	}
	
	public boolean gagné() {
		return(bidons.get(0).getVolume() == volumeVisé);
	}
	
}
	
