package v1;

//le receveur (au sens du DP), c'est à dire l'objet manipulé par les commandes
//ou receveur des commandes

public class Bidon {
	
	protected int capacite;
	protected int volume;
	protected int numero;
	
	public Bidon(int vmax,int numero){
		this.numero=numero;
		this.capacite = vmax;
	}

	public String toStringContent() {
			return "b" + numero + "(" + volume + "/" + capacite + ")";
	}
	
	/*
	 * n'affiche que le numéro du bidon, pas son volume. Lorsqu'une commande est
	 * stockée dans l'historique, les valeurs d'attributs du bidon qu'elle référence
	 * ne sont plus ce qu'elles étaient au moment ou la commande a été exécutée;
	 * leur affichage crée donc une confusion. 
	 * A faire : un toString qui affiche les
	 * valeurs d'attributs du moment de l'exécution. Solution1 : faire une copie
	 * profonde de la commande pour insertion dans l'historique. Solution 2, utiliser
	 * l'attribut volumeDéplacé pour afficher les valeurs correctes.
	 */	
	
	public String toString() {
		return "b" + numero;
	}		
	
	public int getVolume() {
		return volume;
	}

	public void setVolume(int mVol) {
		this.volume = mVol;
	}
	
	public int getVolumeMax() {
		return capacite;
	}
	
	public void vider(){
		this.setVolume(0);
	}
	
	public void remplir(){
		setVolume(capacite);
	}
	
	public int transvaser(Bidon dest){
		int vdeplace;
		int sum = this.getVolume()+dest.getVolume();
		
		if( sum > dest.getVolumeMax()){
			vdeplace = dest.getVolumeMax() - dest.getVolume();
			dest.setVolume(dest.getVolumeMax());
			this.setVolume(this.getVolume() - vdeplace);
		}
		else{
			vdeplace = this.getVolume();
			dest.setVolume(sum);
			this.vider();
		}
		
		return vdeplace;
	}
}
