package v1;
import java.util.Stack;

/**
 * @author Ahmad BEDJA BOANA
 */

public class Lanceur {
	//lanceur, invoker ou "caller"
	//reçoit les demandes d'execution de commandes envoyées par le client joueur
	//gère l'historique
	
	//première version du lanceur, undo est une méthode du lanceur, pas une commande.
	//Undo n'est pas mémorisé dans l'historique
	
	protected Stack<ICommande> history;
	protected BasePartie partie;
	
	protected static boolean trace;
	public static void trace() { trace = true; }
	public static void untrace() { trace = false; }
	
	public Lanceur(BasePartie p){ 
		this.history = new Stack<ICommande>();
		this.partie = p;}
	
	public boolean hasNextUndo(){ return (!history.isEmpty()); }
	
	public void pushCommand(ICommande c){ //gérer les exceptions ...
		if (trace) System.out.println("" + c);
		c.execute();
		history.push(c);
		if (trace) partie.printEtats();}
	
	//version 1 : un ordre undo défait la dernière action mais ne crée pas une
	//commande. Donc ce undo n'est pas mémorisé dans l'historique qui 
	//perd son dernier élément. On perd l'information qu'une commande a été
	//exécutée puis annulée.
	
	public void undo(){
		ICommande c = history.lastElement();
		if (trace) System.out.println("undo " + c.toString() + "!");
		c.undo();
		history.pop();
		if (trace) partie.printEtats();
	}
	
	public Stack<ICommande> getHistory(){ return history; }
	
	public void raz() {
		//undo toutes les commandes déjà jouées
		while(this.hasNextUndo())
			this.undo(); 	
	}	
}
