package v2;
import v1.ICommande;
import v1.BasePartie;
import java.util.Stack;



/**
 * @author Ahmad BEDJA BOANA
 */

public class Lanceur {
	//invoker ou "caller"
	//reçoit les demandes d'execution de commandes envoyées par le client joueur
	//gère l'historique
	
	//Version 2 du lanceur, Undo est une commande
	//Undo n'est pas mémorisé dans l'historique
	
	protected Stack<ICommande> history;
	protected BasePartie partie;
	
	protected static boolean trace;
	public static void trace() { trace = true; }
	public static void untrace() { trace = false; }
	
	public Lanceur(BasePartie p){ 
		this.history = new Stack<ICommande>();
		this.partie = p;}
	
	public void pushCommand(ICommande c){ //gérer les exceptions ...
		this.executeCommand(c);
		history.push(c);}
	
	public void executeCommand(ICommande c) {
		if (trace) System.out.println("" + c);
		c.execute();
		if (trace) partie.printEtats();
		}
	
	//version 2 : Undo est une commande avec sémantique simple
	//défait la dernière action, n'est pas empilée.
	//le fait que c a été fait puis défait disparait de l'historique
	//les undos successifs ne posent donc pas de question

	public void undo() {
		ICommande c = history.pop();
		this.executeCommand(new Undo(c));
	}
	
	public Stack<ICommande> getHistory(){ return history; }
	
	public void raz() {
		//à réécrire ... ?
		//undo toutes les commandes déjà jouées
		//while(!history.isEmpty())
			//this.undoLastCommand(); 	
	}	
}
